//+------------------------------------------------------------------+
//|                                                    Must_Line.mq4 |
//|                                         Must Line                |
//|                                        by Global Lloyds Co, LTD. |
//+------------------------------------------------------------------+
#property copyright "Copyright (c), Global Lloyds Co, LTD."

#property indicator_chart_window

extern int minBars=2;
extern color LineColor=Yellow;
extern int LineWidth=2;
extern int LineStyle=STYLE_SOLID;
extern int basePeriod= PERIOD_M15;

double zz[];
double zzH[];
double zzL[];

static string strObjKey="__Swing_ZZ_Line_";
static datetime dtLastZ=0;

int init()
{
	IndicatorBuffers(4);
	SetIndexBuffer(1,zz);
	SetIndexBuffer(2,zzH);
	SetIndexBuffer(3,zzL);
	SetIndexEmptyValue(1,0.0);
	SetIndexEmptyValue(2,0.0);
	SetIndexEmptyValue(3,0.0);
	IndicatorShortName("Swing_ZZ_Line("+minBars+")");
	dtLastZ=0;
	return(0);
}

int deinit()
{
	DeleteHLines();
	return(0);
}

int start()
{
	double lLast=0,hLast=0;
	int fs=0;
	int ai,bi,ai0,aip0,bi0,bip0;
	datetime tai,tbi,taip,tbip,ti;

	double lLast_m=0,hLast_m=0;
	int countBarExt,countBarl,countBarh;
	int i,n;

	ArrayInitialize(zz,0.0);
	ArrayInitialize(zzH,0.0);
	ArrayInitialize(zzL,0.0);

	for(i=iBars(NULL,basePeriod)-1;i>=0;i--){
		if(lLast==0){lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);ai=i;bi=i;}
		if(ti!=iTime(NULL,basePeriod,i)){
			ti=iTime(NULL,basePeriod,i);
			if(lLast_m==0&&hLast_m==0){
				if(lLast>iLow(NULL,basePeriod,i)&&hLast<iHigh(NULL,basePeriod,i)){
					lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);lLast_m=iLow(NULL,basePeriod,i);hLast_m=iHigh(NULL,basePeriod,i);countBarExt++;
					if(fs==1){countBarl=countBarExt;ai=i;tai=iTime(NULL,basePeriod,i);}
					else if(fs==2){countBarh=countBarExt;bi=i;tbi=iTime(NULL,basePeriod,i);}
					else{countBarl++;countBarh++;}
				}else if(lLast<=iLow(NULL,basePeriod,i)&&hLast<iHigh(NULL,basePeriod,i)){
					lLast_m=0;hLast_m=iHigh(NULL,basePeriod,i);countBarl=0;countBarExt=0;
					if(fs!=1)countBarh++;else{lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);lLast_m=0;hLast_m=0;ai=i;tai=iTime(NULL,basePeriod,i);}
				}else if(lLast>iLow(NULL,basePeriod,i)&&hLast>=iHigh(NULL,basePeriod,i)){
					lLast_m=iLow(NULL,basePeriod,i);hLast_m=0;countBarh=0;countBarExt=0;
					if(fs!=2)countBarl++;else{lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);lLast_m=0;hLast_m=0;bi=i;tbi=iTime(NULL,basePeriod,i);}
				}
			}else if(lLast_m>0&&hLast_m>0){
				if(lLast_m>iLow(NULL,basePeriod,i)&&hLast_m<iHigh(NULL,basePeriod,i)){
					lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);lLast_m=iLow(NULL,basePeriod,i);hLast_m=iHigh(NULL,basePeriod,i);countBarExt++;
					if(fs==1){countBarl=countBarExt;ai=i;tai=iTime(NULL,basePeriod,i);}
					else if(fs==2){countBarh=countBarExt;bi=i;tbi=iTime(NULL,basePeriod,i);}
					else{countBarl++;countBarh++;}
				}else if(lLast_m<=iLow(NULL,basePeriod,i)&&hLast_m<iHigh(NULL,basePeriod,i)){
					lLast_m=0;hLast_m=iHigh(NULL,basePeriod,i);countBarl=0;countBarExt=0;
					if(fs!=1)countBarh++;else{lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);lLast_m=0;hLast_m=0;ai=i;tai=iTime(NULL,basePeriod,i);}
				}else if(lLast_m>iLow(NULL,basePeriod,i)&&hLast_m>=iHigh(NULL,basePeriod,i)){
					lLast_m=iLow(NULL,basePeriod,i);hLast_m=0;countBarh=0;countBarExt=0;
					if(fs!=2)countBarl++;else{lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);lLast_m=0;hLast_m=0;bi=i;tbi=iTime(NULL,basePeriod,i);}
				}
			}else if(lLast_m>0){
				if(lLast_m>iLow(NULL,basePeriod,i)&&hLast<iHigh(NULL,basePeriod,i)){
					lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);lLast_m=iLow(NULL,basePeriod,i);hLast_m=iHigh(NULL,basePeriod,i);countBarExt++;
					if(fs==1){countBarl=countBarExt;ai=i;tai=iTime(NULL,basePeriod,i);}
					else if(fs==2){countBarh=countBarExt;bi=i;tbi=iTime(NULL,basePeriod,i);}
					else{countBarl++;countBarh++;}
				}else if(lLast_m<=iLow(NULL,basePeriod,i)&&hLast<iHigh(NULL,basePeriod,i)){
					lLast_m=0;hLast_m=iHigh(NULL,basePeriod,i);countBarl=0;countBarExt=0;
					if(fs!=1)countBarh++;else{lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);lLast_m=0;hLast_m=0;ai=i;tai=iTime(NULL,basePeriod,i);}
				}else if(lLast_m>iLow(NULL,basePeriod,i)&&hLast>=iHigh(NULL,basePeriod,i)){
					lLast_m=iLow(NULL,basePeriod,i);hLast_m=0;countBarh=0;countBarExt=0;
					if(fs!=2)countBarl++;else{lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);lLast_m=0;hLast_m=0;bi=i;tbi=iTime(NULL,basePeriod,i);}
				}
			}else if(hLast_m>0){
				if(lLast>iLow(NULL,basePeriod,i)&&hLast_m<iHigh(NULL,basePeriod,i)){
					lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);lLast_m=iLow(NULL,basePeriod,i);hLast_m=iHigh(NULL,basePeriod,i);countBarExt++;
					if(fs==1){countBarl=countBarExt;ai=i;tai=iTime(NULL,basePeriod,i);}
					else if(fs==2){countBarh=countBarExt;bi=i;tbi=iTime(NULL,basePeriod,i);}
					else{countBarl++;countBarh++;}
				}else if(lLast<=iLow(NULL,basePeriod,i)&&hLast_m<iHigh(NULL,basePeriod,i)){
					lLast_m=0;hLast_m=iHigh(NULL,basePeriod,i);countBarl=0;countBarExt=0;
					if(fs!=1)countBarh++;else{lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);lLast_m=0;hLast_m=0;ai=i;tai=iTime(NULL,basePeriod,i);}
				}else if(lLast>iLow(NULL,basePeriod,i)&&hLast_m>=iHigh(NULL,basePeriod,i)){
					lLast_m=iLow(NULL,basePeriod,i);hLast_m=0;countBarh=0;countBarExt=0;
					if(fs!=2)countBarl++;else{lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);lLast_m=0;hLast_m=0;bi=i;tbi=iTime(NULL,basePeriod,i);}
				}
			}
			if(fs==0){
				if(lLast<lLast_m&&hLast>hLast_m){
					lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);ai=i;bi=i;
					countBarl=0;countBarh=0;countBarExt=0;
				}
				if(countBarh>countBarl&&countBarh>countBarExt&&countBarh>minBars){
					lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);lLast_m=0;hLast_m=0;
					fs=1;countBarh=0;countBarl=0;countBarExt=0;
					zz[bi]=iLow(NULL,basePeriod,bi);zzL[bi]=iLow(NULL,basePeriod,bi);zzH[bi]=0;
					ai=i;tai=iTime(NULL,basePeriod,i);
				}else if(countBarl>countBarh&&countBarl>countBarExt&&countBarl>minBars){
					lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);lLast_m=0;hLast_m=0;
					fs=2;countBarl=0;countBarh=0;countBarExt=0;
					zz[ai]=iHigh(NULL,basePeriod,ai);zzH[ai]=iHigh(NULL,basePeriod,ai);zzL[ai]=0;
					bi=i;tbi=iTime(NULL,basePeriod,i);
				}
			}else{
				if(lLast_m==0&&hLast_m==0){
					countBarl=0;countBarh=0;countBarExt=0;
				}
				if(fs==1){
					if(countBarl>countBarh&&countBarl>countBarExt&&countBarl>minBars){
						ai0=iBarShift(NULL,basePeriod,tai);
						bi0=iBarShift(NULL,basePeriod,tbi);
						fs=2;countBarl=0;
						zz[ai]=iHigh(NULL,basePeriod,ai);zzH[ai]=iHigh(NULL,basePeriod,ai);zzL[ai]=0;
						bi=i;tbi=iTime(NULL,basePeriod,i);
						lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);lLast_m=0;hLast_m=0;
						for(n=0;countBarExt<minBars;n++){
							if(lLast<iLow(NULL,basePeriod,i+n+1)&&hLast>iHigh(NULL,basePeriod,i+n+1)){
								countBarExt++;countBarh++;lLast=iLow(NULL,basePeriod,i+n+1);hLast=iHigh(NULL,basePeriod,i+n+1);hLast_m=iHigh(NULL,basePeriod,i);
							}else break;
						}
						lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);
					}
				}
				if(fs==2){
					if(countBarh>countBarl&&countBarh>countBarExt&&countBarh>minBars){
						ai0=iBarShift(NULL,basePeriod,tai);
						bi0=iBarShift(NULL,basePeriod,tbi);
						fs=1;countBarh=0;
						zz[bi]=iLow(NULL,basePeriod,bi);zzL[bi]=iLow(NULL,basePeriod,bi);zzH[bi]=0;
						ai=i;tai=iTime(NULL,basePeriod,i);
						lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);lLast_m=0;hLast_m=0;
						for(n=0;countBarExt<minBars;n++){
							if(lLast<iLow(NULL,basePeriod,i+n+1)&&hLast>iHigh(NULL,basePeriod,i+n+1)){
								countBarExt++;countBarl++;lLast=iLow(NULL,basePeriod,i+n+1);hLast=iHigh(NULL,basePeriod,i+n+1);lLast_m=iLow(NULL,basePeriod,i);
							}else break;
						}
						lLast=iLow(NULL,basePeriod,i);hLast=iHigh(NULL,basePeriod,i);
					}
				}
			}
		}
		if(i==0){
			if(hLast<iHigh(NULL,basePeriod,i)&&fs==1){
				ai=i;tai=iTime(NULL,basePeriod,i);zz[ai]=iHigh(NULL,basePeriod,ai);zzH[ai]=iHigh(NULL,basePeriod,ai);zzL[ai]=0;
			}else if(lLast>iLow(NULL,basePeriod,i)&&fs==2){
				bi=i;tbi=iTime(NULL,basePeriod,i);zz[bi]=iLow(NULL,basePeriod,bi);zzL[bi]=iLow(NULL,basePeriod,bi);zzH[bi]=0;
			}
			ai0=iBarShift(NULL,basePeriod,tai);
			bi0=iBarShift(NULL,basePeriod,tbi);
			if(bi0>1)if(fs==1){for(n=bi0-1;n>=0;n--){zzH[n]=0.0;zz[n]=0.0;}zz[ai0]=iHigh(NULL,basePeriod,ai0);zzH[ai0]=iHigh(NULL,basePeriod,ai0);zzL[ai0]=0.0;}
			if(ai0>1)if(fs==2){for(n=ai0-1;n>=0;n--){zzL[n]=0.0;zz[n]=0.0;}zz[bi0]=iLow(NULL,basePeriod,bi0);zzL[bi0]=iLow(NULL,basePeriod,bi0);zzH[bi0]=0.0;}
			if(ti<iTime(NULL,basePeriod,1))i=2;
		}
	}
	if((0<zz[0]&&dtLastZ!=iTime(NULL,basePeriod,0))||0==dtLastZ)DrawHLines();
	return(0);
}

void DrawHLines()
{
	int n=0;
	string sn;
	DeleteHLines();
	for(int i=0;i<iBars(NULL,basePeriod);i++){
		if(0<zz[i]){
			if(0<n){
				sn=strObjKey+TimeToStr(iTime(NULL,basePeriod,i));
				if(ObjectCreate(sn,OBJ_HLINE,0,0,zz[i])){
					ObjectSet(sn,OBJPROP_COLOR,LineColor);
					ObjectSet(sn,OBJPROP_STYLE,LineStyle);
					ObjectSet(sn,OBJPROP_WIDTH,LineWidth);
				}
				if(10==n)break;
				n++;
			}else{
				dtLastZ=iTime(NULL,basePeriod,i);
				n++;
			}
		}
	}
}

void DeleteHLines()
{
	string sn;
	for(int i=ObjectsTotal()-1;0<=i;i--){
		sn=ObjectName(i);
		if(strObjKey==StringSubstr(sn,0,StringLen(strObjKey)))ObjectDelete(sn);
	}
}



